import { IgcGridStateComponent as Component } from 'igniteui-webcomponents-grids/grids/index.js';
import type { IgcGridStateComponentEventMap } from 'igniteui-webcomponents-grids/grids/index.js';
import { type EventName } from '../react-props.js';
/**
 * State component allows saving and restoring the state of the grid features.
 * @fires stateParsed - Event emitted when set state is called with a string.  Returns the parsed state object so that it can be further modified before applying to the grid.
 */
export declare const IgrGridState: import("../react-props.js").ReactWebComponent<Component, {
    onStateParsed: EventName<IgcGridStateComponentEventMap["stateParsed"]>;
}, {}>;
export type IgrGridState = Component;
/** @deprecated Module register is no longer needed and can be removed */
export declare const IgrGridStateModule: typeof Component;
